Loading...
Searching...
No Matches
gtsam::EliminatableClusterTree< BAYESTREE, GRAPH > Class Template Reference

## Detailed Description

template<class BAYESTREE, class GRAPH>
class gtsam::EliminatableClusterTree< BAYESTREE, GRAPH >

A cluster-tree that eliminates to a Bayes tree.

Inheritance diagram for gtsam::EliminatableClusterTree< BAYESTREE, GRAPH >:

## Public Member Functions

Standard Interface
std::pair< boost::shared_ptr< BayesTreeType >, boost::shared_ptr< FactorGraphType > > | eliminate (const Eliminate &function) const
| Eliminate the factors to a Bayes tree and remaining factor graph.
Advanced Interface
const FastVector< sharedFactor > & | remainingFactors () const
| Return the remaining factors that are not pulled into elimination.
Public Member Functions inherited from gtsam::ClusterTree< GRAPH >
| ClusterTree ()
| Default constructor.
void | print (const std::string &s="", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const
| Print the cluster tree.
void | addRoot (const boost::shared_ptr< Cluster > &cluster)
void | addChildrenAsRoots (const boost::shared_ptr< Cluster > &cluster)
size_t | nrRoots () const
const FastVector< sharedNode > & | roots () const
| Return the set of roots (one for a tree, multiple for a forest).
const Cluster & | operator[] (size_t i) const

## Public Types

typedef BAYESTREE | BayesTreeType
| The BayesTree type produced by elimination.
typedef GRAPH | FactorGraphType
| The factor graph type.
typedef EliminatableClusterTree< BAYESTREE, GRAPH > | This
| This class.
typedef boost::shared_ptr< This > | shared_ptr
| Shared pointer to this class.
typedef BAYESTREE::ConditionalType | ConditionalType
| The type of conditionals.
typedef boost::shared_ptr< ConditionalType > | sharedConditional
| Shared pointer to a conditional.
typedef GRAPH::Eliminate | Eliminate
| Typedef for an eliminate subroutine.
typedef GRAPH::FactorType | FactorType
| The type of factors.
typedef boost::shared_ptr< FactorType > | sharedFactor
| Shared pointer to a factor.
Public Types inherited from gtsam::ClusterTree< GRAPH >
typedef GRAPH | FactorGraphType
| The factor graph type.
typedef ClusterTree< GRAPH > | This
| This class.
typedef boost::shared_ptr< This > | shared_ptr
| Shared pointer to this class.
typedef GRAPH::FactorType | FactorType
| The type of factors.
typedef boost::shared_ptr< FactorType > | sharedFactor
| Shared pointer to a factor.
typedef boost::shared_ptr< Cluster > | sharedCluster
| Shared pointer to Cluster.
typedef Cluster | Node
typedef sharedCluster | sharedNode

## Protected Member Functions

Standard Constructors
| EliminatableClusterTree (const This &other)
| Copy constructor - makes a deep copy of the tree structure, but only pointers to factors are copied, factors are not cloned.
Details
This & | operator= (const This &other)
| Assignment operator - makes a deep copy of the tree structure, but only pointers to factors are copied, factors are not cloned.
| EliminatableClusterTree ()
| Default constructor to be used in derived classes.
| ClusterTree (const This &other)
| Copy constructor - makes a deep copy of the tree structure, but only pointers to factors are copied, factors are not cloned.
This & | operator= (const This &other)
| Assignment operator - makes a deep copy of the tree structure, but only pointers to factors are copied, factors are not cloned.

## Protected Attributes

FastVector< sharedFactor > | remainingFactors_
Protected Attributes inherited from gtsam::ClusterTree< GRAPH >
FastVector< sharedNode > | roots_
| concept check

## Member Function Documentation

## eliminate()

template<class BAYESTREE, class GRAPH>

std::pair< boost::shared_ptr< BAYESTREE >, boost::shared_ptr< GRAPH > > gtsam::EliminatableClusterTree< BAYESTREE, GRAPH >::eliminate | ( | const Eliminate & | function | ) | const

Eliminate the factors to a Bayes tree and remaining factor graph.

Parameters

  function | The function to use to eliminate, see the namespace functions in GaussianFactorGraph.h

Returns
  The Bayes tree and factor graph resulting from elimination

The documentation for this class was generated from the following files:

- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/inference/BayesTree.h
- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/inference/ClusterTree.h
- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/inference/ClusterTree-inst.h